<template lang="pug">
<b-modal :id="'list_mode_modal'" size="lg" hide-header title-class="h5" modal-class="edit_modal edit_list_mode_modal" ok-only>
    <b-tabs pills card vertical class="list_mode_modal" nav-wrapper-class="list_mode_modal__sidebar">
        <b-tab title="Tab 1" active class="list_mode_modal__page">
            <draggable v-model="secondaryComponent" id="list_mode_modal__page_list" class="list-group componentList" ghostClass="list_mode_modal__page_item--ghost" :group="{name: 'shared'}" animation="150" handle=".list_mode_modal__page_handle">
                <b-list-group-item class="list_mode_modal__page_item" :class="`list_mode_modal__page_item${item.id}`" :key="item.id" v-for="(item, index) in secondaryComponent">
                    b-img.list_mode_modal__page_handle.mr-3.p-1(
                        src="@/assets/svg/menu.svg",
                        width="20"
                    )
                    b-img.list_mode_modal__page_img(
                        :src="item.content.img ? item.content.img : require('@/assets/svg/default_' + item.name + '.svg')"
                    )
                    .list_mode_modal__page_item__content
                        span(v-if="item.name == 'texts'") {{ item.content.data.content[1].content[0].text }}
                        span(v-else-if="item.name == 'images'") {{ item.content.title }}
                        span(v-else-if="item.name == 'videos'") 
                            b-link(:href="regexURL(item.content.url)", target="_blank") {{ regexURL(item.content.url) }}
                        code(v-else-if="item.name == 'codes'") {{ item.content.script.substring(0, 20) }}
                    .list_mode_modal__page_edit
                        <BIconPencil class="mr-2" v-if="item.name != 'texts'" @click="openModal(item.name,item.id)"/>
                        <BIconXSquare @click="templateRemove(item.id)"/>
                    <edit_img v-if="item.name == 'images'" :index="item.id" :default_image="item.content.img" mode="list"/>
                    <edit_code v-else-if="item.name == 'codes'" :index="item.id" :default_code="item.content.script" mode="list" />
                    <edit_video v-else-if="item.name == 'videos'" :index="item.id" :default_url="item.content.url" mode="list" />
                    <edit_product v-else-if="item.name == 'products'" :index="item.id" :default_content="item.content.products" mode="list" />
                </b-list-group-item>
            </draggable>
        </b-tab>
    </b-tabs>
</b-modal>
</template>

<script>
//Bicon
import {
    BIconXSquare,
    BIconPencil
} from "bootstrap-vue";
//vuex
import {
    mapGetters
} from "vuex";
//comp
import draggable from "vuedraggable";
import edit_img from "@/components/modal/image/MI-image";
import edit_code from "@/components/modal/code/MC-script";
import edit_video from "@/components/modal/video/MV-link";
import edit_product from "@/components/modal/product/MP-product";
export default {
    props: {},
    data() {
        return {};
    },
    computed: {
        secondaryComponent: {
            get() {
                return this.$store.state.secondaryComponent;
            },
            set(value) {
                this.$store.commit("UPDATE_SECONDARYCOMPONENT", value);
            },
        },
    },
    components: {
        draggable,
        BIconXSquare,
        BIconPencil,
        edit_img,
        edit_code,
        edit_video,
        edit_product,
    },
    methods: {
        openModal(type, id) {
            switch (type) {
                case "images":
                    this.$bvModal.show(`edit_image_list_${id}`);
                    break;
                case "codes":
                    this.$bvModal.show(`code_modal_list_${id}`);
                    break;
                case "videos":
                    this.$bvModal.show(`edit_link_list_${id}`);
                    break;
                case "products":
                    this.$bvModal.show(`edit_product_modal_list_${id}`);
                    break;
                default:
                    break;
            }
        },
        templateRemove(id) {
            this.$store.commit("REMOVE_SECONDARYCOMPONENT", id);
        },
        regexURL(URL) {
            const regex = /(?<=src=").*?(?=[\?"])/gm;
            const str = URL;
            let m;

            while ((m = regex.exec(str)) !== null) {
                if (m.index === regex.lastIndex) {
                    regex.lastIndex++;
                }

                return m[0];
            }
        },
    },
    mounted() {},
};
</script>

<style lang="scss">
.list_mode_modal {
    position: relative;
    width: 100%;
    height: 420px;
    display: flex;
    align-items: stretch;

    &__sidebar {
        position: relative;
        background-color: #6c757d;

        .nav-link {
            &.active {}
        }
    }

    &__page {
        height: 100%;
        max-height: 420px;
        overflow: scroll;

        &_edit {
            position: absolute;
            right: 20px;
            top: 50%;
            transform: translateY(-50%);

            svg {
                cursor: pointer;

                &:hover {}
            }
        }

        &_item {
            position: relative;
            display: flex;
            align-items: center;
            padding: 10px;

            &--ghost {
                opacity: 0.4;
            }

            &:last-child {
                margin-bottom: 20px;
            }
        }

        &_img {
            width: 60px;
            height: 60px;
            margin-right: 15px;
        }
    }
}
</style>
